// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
////////////////////////////////////////////////////////////////////////////////

import com.code_intelligence.jazzer.api.FuzzedDataProvider;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;

public class JsonFuzzer {
  public static void fuzzerTestOneInput(FuzzedDataProvider data) {
    ObjectMapper mapper = new ObjectMapper();
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.ALLOW_COMMENTS);
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.ALLOW_SINGLE_QUOTES);
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES);
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.ALLOW_YAML_COMMENTS);
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.IGNORE_UNDEFINED);
    if (data.consumeBoolean())
      mapper.enable(JsonParser.Feature.STRICT_DUPLICATE_DETECTION);

    try {
      mapper.readTree(data.consumeRemainingAsBytes());
    } catch (IOException ignored) {
    }
  }
}
